杨氏矩阵和杨辉三角


杨氏矩阵

有一个数字矩阵,矩阵的每行从左到右是递增的,矩阵从上到下是递增的,请编写程序在这样的矩阵中查找某个数字是否存在。

要求:时间复杂度小于O(N);

分析

若要满足要求时间复杂度小于O(N),就不能每一行一个个找。

根据杨氏矩阵的特点(行递增、列递增 ),我们可以从矩阵的右上角开始,

就比如我们要找上图中的数字7,

9>7,因为**列递增 ,9是该列最小的数字,都大于7,**所以第4列的数字都比7大,排除第4列

右上角 数字变为了6**,6<7,** 因为行 **递增,6是该行最大的数字,都小于7,**所以第1行的数字都比7小,排除第1行

右上角数字变为了7,7=7,找到了

代码实现

复制代码
//             假设有4列,x行,y列,key是要找的数字
int FindNum(int arr[][4], int x, int y, int key)
{
	int i = 0;
	int j = y - 1;
	//满足此循环,i和j都是合法的
	while (j >= 0 && i < x)
	{
		if (arr[i][j] > key)
		{
			j--;
		}
		else if (arr[i][j] < key)
		{
			i++;
		}
		else
		{
			return 1;//找到了
		}
	}
	return 0;//没找到
}

杨辉三角

在屏幕上打印杨辉三角

分析

杨辉三角的特点:除了外围的数字为1,其他满足 数字 = 这列的上一行 数字 + 上一行前一列数字

我们定义有i行j列

其中数字是1的下标满足:j==0或i==j

其他数字的下标满足:ij = i-1j + i-1j-1

代码实现

复制代码
#include<stdio.h>
//在屏幕上打印杨辉三角。
void YanghuiTriangle(int arr[][4], int n)
{
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j <= i; j++)
		{
			if (j == 0 || i == j)
			{
				arr[i][j] = 1;
			}
			else
			{
				arr[i][j] = arr[i - 1][j] + arr[i - 1][j - 1];
			}
		}
	}
	//打印
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j <= i; j++)
		{
			printf("%d ", arr[i][j]);
		}
		printf("\n");
	}
}
int main()
{
	int arr[4][4] = { 0 };
	YanghuiTriangle(arr, 4);

	return 0;
}
相关推荐
Navigator_Z4 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
D e re k ZH4 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶5 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
雪落漂泊5 小时前
C++算法 二分查找篇(上)
开发语言·c++·算法
LabVIEW开发7 小时前
LabVIEW 连接板:28 个端子怎么排,优先级怎么定
java·算法·labview
严肃小白兔9 小时前
MATLAB 数值计算中的精度与误差问题:浮点运算、误差传播与数值稳定性
人工智能·算法·matlab
青少儿编程课堂10 小时前
蓝桥杯青少组图形化省考报名倒计时·全国青少年信息素养大赛·电子学会图形化考级:校园黑白棋人机对战解析
c++·python·算法·bfs·信息学竞赛
jktantan11 小时前
注解式脱敏:用 Jackson 的 ContextualSerializer 做字段级策略(一)
spring boot·后端·算法·spring cloud·系统架构
Dream it possible!1 天前
LeetCode 面试经典 150_多维动态规划_交错字符串(97_C++_中等)
算法·leetcode·面试·动态规划